import { JSX } from "preact";
import { ReactNode } from "../../../modules/common/React";
import { JSXInternal } from "preact/src/jsx";
import CSSProperties = JSXInternal.CSSProperties;
interface BaseProps {
    children: ReactNode;
    className?: string;
    originalHeight: number;
    originalWidth: number;
    style?: CSSProperties;
}
interface HeightProps extends BaseProps {
    height: number;
}
interface WidthProps extends BaseProps {
    width: number;
}
declare type Props = HeightProps | WidthProps;
/**
 * IE11 doesn't like it when setting only width or height, so this utility makes it easier to set both.
 */
export declare const ResizedSvg: ({ children, className, originalHeight, originalWidth, style, ...rest }: Props) => JSX.Element;
export {};
