import { JSX } from "preact";
import { ReactNode } from "../../modules/common/React";
import { Rect } from "../../modules/common/Rect";
export interface GeometryWithProvenance<K> {
    lastUpdatedBy: K;
}
interface Props<T extends GeometryWithProvenance<K>, K extends string> {
    boundary: Rect;
    children?: ReactNode;
    className?: string;
    geometryMutatorId: K;
    onMove: (xDelta: number, yDelta: number, start: T) => void;
    startingValue: T;
    style?: JSX.CSSProperties;
}
export declare const Draggable: <T extends GeometryWithProvenance<K>, K extends string>({ boundary, children, className, onMove: onMoveCallback, style, startingValue, geometryMutatorId }: Props<T, K>) => JSX.Element;
export {};
